<?php
/**
 * 模型内容信息_管理全球国家及州/省信息
 * @作者 phpok.com <admin@phpok.com>
 * @版权 深圳市锟铻科技有限公司
 * @主页 http://www.phpok.com
 * @版本 5.x
 * @许可 http://www.phpok.com/lgpl.html PHPOK开源授权协议：GNU Lesser General Public License
 * @时间 2019年05月27日 19时51分
**/
namespace phpok\app\model\worlds;
/**
 * 安全限制，防止直接访问
**/
if(!defined("PHPOK_SET")){
	exit("<h1>Access Denied</h1>");
}
class model extends \phpok_model
{
	public function __construct()
	{
		parent::model();
	}

	/**
	 * 自定义查询
	 * @参数 $condition 查询条件
	 * @参数 $orderby 自定义排序
	 * @参数 $pri 指定主键ID
	**/
	public function get_all($condition='',$orderby='',$pri='',$offset=0,$psize=0)
	{
		if(!$orderby){
			$orderby = " taxis ASC,name_en ASC ";
		}
		$sql = "SELECT * FROM ".$this->db->prefix."world_location WHERE ".$condition." ORDER BY ".$orderby;
		if($psize && intval($psize)>0){
			$sql .= " LIMIT ".intval($offset).",".intval($psize);
		}
		return $this->db->get_all($sql,$pri);
	}

	public function update_pid($id,$pid=0)
	{
		$sql = "UPDATE ".$this->db->prefix."world_location SET pid='".$pid."' WHERE id='".$id."'";
		return $this->db->query($sql);
	}

	public function update_status($id,$status=0)
	{
		$sql = "UPDATE ".$this->db->prefix."world_location SET status='".$status."' WHERE id='".$id."'";
		return $this->db->query($sql);
	}

	//获取单条信息
	public function get_one($id)
	{
		$sql = "SELECT * FROM ".$this->db->prefix."world_location WHERE id='".$id."'";
		return $this->db->get_one($sql);
	}

	public function parent_all($id,$pri='')
	{
		$sql = "SELECT * FROM ".$this->db->prefix."world_location WHERE pid='".$id."'";
		return $this->db->get_all($sql,$pri);
	}

	
	public function pricelist($id)
	{
		$sql = "SELECT * FROM ".$this->db->prefix."world_price WHERE tid='".$id."'";
		$tmplist = $this->db->get_all($sql);
		if(!$tmplist){
			return false;
		}
		$rslist = array();
		foreach($tmplist as $key=>$value){
			if(!$rslist[$value['region_id']]){
				$rslist[$value['region_id']] = array();
			}
			$rslist[$value['region_id']][$value['vtype']] = $value['price'];
		}
		return $rslist;
	}

	public function del($id)
	{
		if(!$id){
			return false;
		}
		$sql = "DELETE FROM ".$this->db->prefix."world_location WHERE id='".$id."'";
		return $this->db->query($sql);
	}

	public function save($data,$id=0)
	{
		if(!$data || !is_array($data)){
			return false;
		}
		if($id){
			return $this->db->update($data,"world_location",array('id'=>$id));
		}
		return $this->db->insert($data,'world_location');
	}

	public function group_countries()
	{
		$continent = $this->get_all('pid=0 AND status=1');
		if(!$continent){
			return false;
		}
		$ids = array();
		foreach($continent as $key=>$value){
			$ids[] = $value['id'];
		}
		$condition = "pid IN(".implode(",",$ids).") AND status=1";
		$tmplist = $this->get_all($condition);
		if(!$tmplist){
			return false;
		}
		foreach($tmplist as $key=>$value){
			$sublist[$value['pid']][] = $value;
		}
		$grouplist = array();
		foreach($continent as $key=>$value){
			if($sublist[$value['id']]){
				$value['rslist'] = $sublist[$value['id']];
				$grouplist[$key] = $value;
			}
		}
		return $grouplist;
	}
}
