<?php
/**
 * 接入节点_管理全球国家及州/省信息
 * @作者 phpok.com <admin@phpok.com>
 * @版权 深圳市锟铻科技有限公司
 * @主页 http://www.phpok.com
 * @版本 5.x
 * @许可 http://www.phpok.com/lgpl.html PHPOK开源授权协议：GNU Lesser General Public License
 * @时间 2019年05月27日 19时51分
**/
namespace phpok\app\worlds;
/**
 * 安全限制，防止直接访问
**/
if(!defined("PHPOK_SET")){
	exit("<h1>Access Denied</h1>");
}
class nodes_phpok extends \_init_auto
{
	public function __construct()
	{
		parent::__construct();
	}

	//解决不同国家不同价格
	public function PHPOK_arclist()
	{
		$rslist = $this->data('rslist');
		$pid = $this->data('pid');
		if(!$rslist || !is_array($rslist) || !$pid || !is_numeric($pid)){
			return false;
		}
		$ids = array_keys($rslist);
		$region = $this->session->val('region');
		if(!$region){
			return false;
		}
		//读取这个国家的价格
		$sql = "SELECT * FROM ".$this->db->prefix."list_price WHERE tid IN(".implode(",",$ids).") AND region_id='".$region['id']."' AND vtype='price'";
		$tmplist = $this->db->get_all($sql);
		if(!$tmplist){
			return false;
		}
		foreach($tmplist as $key=>$value){
			if($value['price']){
				$rslist[$value['tid']]['price'] = $value['price'];
			}
		}
		$this->data('rslist',$rslist);
		return true;
	}

	public function PHPOK_arc()
	{
		$arc = $this->data('arc');
		if(!$arc){
			return false;
		}
		if(!$arc['price']){
			return false;
		}
		$region = $this->session->val('region');
		if(!$region){
			return false;
		}
		//读取这个国家的价格
		$sql = "SELECT * FROM ".$this->db->prefix."world_price WHERE tid='".$arc['id']."' AND region_id='".$region['id']."' AND vtype='price'";
		$tmp = $this->db->get_one($sql);
		if(!$tmp || !$tmp['price']){
			return false;
		}
		$arc['price'] = $tmp['price'];		
		$this->data('arc',$arc);
		return true;
	}

	public function PHPOK_project()
	{
		//这里开始编写PHP代码
	}

	public function PHPOK_catelist()
	{
		//这里开始编写PHP代码
	}

	public function PHPOK_cate()
	{
		//这里开始编写PHP代码
	}

	//全局购物车节点
	public function global_cart_review()
	{
		$address = $this->data("address");
		$totalprice = $this->data("totalprice");
		if(!$totalprice || !$address){
			return false;
		}
		$condition  = "pid='".$this->session->val('country_id')."' ";
		$condition .= "AND name_en='".$address['shipping']['province']."'";
		$info = $this->model('worlds')->get_all($condition);
		if(!$info){
			return false;
		}
		$world = current($info);
		if(!$world || !$world['tax_rate']){
			return false;
		}
		$rate = $world['tax_rate'] > 1 ? round($world['tax_rate']/100,4) : $world['tax_rate'];
		$price = $rate * $totalprice;
		$this->session->assign('tax',$price);
		$this->undata('address');
		$this->undata('totalprice');
		$this->data('tax',$price);
		return true;
	}

	/**
	 * 系统加载站点信息
	**/
	public function SYSTEM_init_site()
	{
		$site_rs = $this->data("site_rs");
		$region = $this->session->val('region');
		if(!$region){
			return false;
		}
		if($region['site_id'] && $region['site_id'] != $site_rs['id']){
			$site_rs = $this->model('site')->site_info($region['site_id']);
		}
		//检测
		if($region['currency_id']){
			$site_rs['currency_id'] = $region['currency_id'];
		}
		if($region['tpl_id']){
			$site_rs['tpl_id'] = $region['tpl_id'];
		}
		if($region['lang_code']){
			$site_rs['lang'] = $region['lang_code'];
		}
		if($region['freight_id']){
			$site_rs['biz_freight'] = $region['freight_id'];
		}
		//消费税比例
		if($region['excise_rate']){
			$site_rs['excise_rate'] = $region['excise_rate'];
		}
		//关税比例
		if($region['tariff_rate']){
			$site_rs['tariff_rate'] = $region['tariff_rate'];
		}
		$this->data("site_rs",$site_rs);
		return true;
	}
}
